/*
Google-Ping Example. 
Change SSID and PASSWORT
 */

#define SSID "[Your SSID]" 
#define PASSWORD "[Your Password]" 

#define DEBUG true

#include <SoftwareSerial.h>

SoftwareSerial esp8266(11, 12);

void setup()
{
  // Open serial communications and wait for port to open:
  Serial.begin(19200);
  // set the data rate for the SoftwareSerial port
  esp8266.begin(19200);


  //Reset Module
  esp8266.println("AT+RST");
  esp8266.setTimeout(5000);
  if (esp8266.find("ready")) {
    Serial.println("Reset OK");
  }
  else
  {
    Serial.println("Reset Error");
  }

  //WLAN-Modus = Station
  esp8266.setTimeout(1000);
  esp8266.println("AT+CWMODE=1");
  if (esp8266.find("OK")) {
    Serial.println("CWMODE OK");
  }
  else
  {
    Serial.println("CWMODE Error");
  }
  //Connect to WLAN, long Timeout
  esp8266.setTimeout(20000);
  esp8266.println("AT+CWJAP=\"" + String(SSID) + "\",\"" + String(PASSWORD) + "\"");
  if (esp8266.find("OK")) {
    Serial.println("WLAN Connect OK");
  }
  else
  {
    Serial.println("WLAN Connect Error");
  }
  
  //Ping the Google-Server
  esp8266.setTimeout(1000);
  esp8266.println("AT+PING=\"www.google.de\"");
  delay(1000);
  if (esp8266.find("OK")) {
    Serial.println("Ping OK");
    digitalWrite(13, HIGH);
  }
  else
  {
    Serial.println("Ping Error");
  }
}

void loop() // run over and over
{
  //Start serial Debug Mode - Type Commandos over serial Monitor
  serialDebug();
}
//-----------------------------------------------Controll ESP-----------------------------------------------------

boolean sendCom(String command, char respond[])
{
  esp8266.println(command);
  if (esp8266.findUntil(respond, "ERROR"))
  {
    return true;
  }
  else
  {
    debug("ESP SEND ERROR: " + command);
    return false;
  }
}

String sendCom(String command)
{
  esp8266.println(command);
  return esp8266.readString();
}



//-------------------------------------------------Debug Functions------------------------------------------------------
void serialDebug() {
  while (true)
  {
    if (esp8266.available())
      Serial.write(esp8266.read());
    if (Serial.available())
      esp8266.write(Serial.read());
  }
}

void debug(String Msg)
{
  if (DEBUG)
  {
    Serial.println(Msg);
  }
}
